//+------------------------------------------------------------------+
//|                                                     _2.mq4 |
//|                                 Copyright  2006,   |
//|         "  ".  |
//|  , , sk@mail.dnepr.net, ICQ 64015987, |
//|                                         http://autograf.dp.ua/.  |
//+------------------------------------------------------------------+

extern int TakeProfit = 6;   // TakeProfit 
extern int StopLoss  = 23;   // StopLoss 
extern int Distan    = 3;    //    
extern int Cls       = 14;   //   **  
extern int period_MA = 139;  //    
//extern int Time_1   = 0;   //    
//extern int Time_2   = 0;   //   
extern int Prots     = 0;    //    
extern int RQF_TEST = 0;
//Kniff`s code
double __buy_lots;
double __sell_lots;
bool __sell_lim;
bool __buy_lim;
double __sell_price;
double __buy_price;
double __sell_TP;
double __buy_TP;
double __sell_SL;
double __buy_SL;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void MyOrderPlaceSell(double l, double pr, double stl, double tkp)
  {
   __sell_lim = true;
   __sell_price = pr;
   __sell_lots = l;
   __sell_TP = tkp;
   __sell_SL = stl;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void MyOrderPlaceBuy(double l, double pr, double stl, double tkp)
  {
   __buy_lim = true;
   __buy_price = pr;
   __buy_lots = l;
   __buy_TP = tkp;
   __buy_SL = stl;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int MyOrderSend(int req_prob, string symbol, int cmd, double volume, double price, 
                int slippage, double stoploss, double takeprofit, 
                string comment = "", int magic = 0, datetime expiration = 0, 
                color arrow_color = CLR_NONE)
  {
   if(IsTesting() && (MathRand() % 100) < req_prob && (cmd == OP_SELL || cmd == OP_BUY))
       return(-1);  //modelling requote
   return(OrderSend(symbol, cmd, volume, price, slippage, stoploss, takeprofit, 
          comment, magic, expiration, arrow_color));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+ 
bool MyOrderClose(int req_prob, int ticket, double lots, double price, int slippage,
                  color Color = CLR_NONE)
  {
   if(IsTesting() && (MathRand() % 100) < req_prob)
       return(false); //modelling requote
   return (OrderClose(ticket, lots, price, slippage, Color));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void ActivateLimits()
  {
//----
   if(__buy_lim && Ask <= __buy_price)
     {
       MyOrderSend(RQF_TEST, Symbol(), OP_BUY, __buy_lots, Ask, 3, __buy_SL, __buy_TP, 
                   "", 0, 0, Blue);
       __buy_lim = false;
     }
//----
   if(__sell_lim && Bid >= __sell_price)
     {
       MyOrderSend(RQF_TEST, Symbol(), OP_SELL, __sell_lots, Bid, 3, __sell_SL, 
                   __sell_TP, "", 0, 0, Red);
       __sell_lim = false;
     }
  }
// Kniff`s code end
//-------------------------------------------------------------------
int
   Nom_bl,   //   BuyLimit
   Nom_sl,   //   SellLimit
   total,    //  
   bl = 0,   // 1 =    BuyLimit
   sl = 0,   // 1 =    SellLimit
   b  = 0,   // 1 =    Buy
   s  = 0;   // 1 =    Sell 
//----
double 
   OP,     // OpenPrice (. )
   SL,     // StopLoss    (..)
   TP,     // TakeProfit  (..)
   dist,   //    (..)
   Level,  // .   .
   OP_bl,  // OpenPrice BuyLimit (. )
   OP_sl,  // OpenPrice SellLimit(. )
   cls,    //   **  (. .)
   MA,     //   ()
   spred,  //  (. )
   Lot;    //  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
  {   
   Level = MarketInfo(Symbol(), MODE_STOPLEVEL); //     
   Level = (Level+1)*Point;   // ?:)
   SL = StopLoss*Point;       // StopLoss    (..)
   TP = TakeProfit*Point;     // TakeProfit  (..)
   dist = Distan*Point;       //    (..)
   cls = Cls*Point;           //   **  (. .)
   spred = Ask - Bid;         //  (. )
   return;
  } 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {   
   total = OrdersTotal(); //  
   bl=0;                  //    
   sl=0;                  //    
   b=0;                   //    
   s=0;                   //    
   MathSrand(TimeCurrent());
   ActivateLimits();
//----
   for(int i = total; i >= 0; i--)  //   
     {                                               
       //----
       if(OrderSelect(i, SELECT_BY_POS) == true &&  //  
          OrderSymbol() == Symbol())
         {
           //----
           if(OrderType() == OP_BUY)  //  Buy
             {
               b = 1;                  //   
               Close_B(OrderTicket(), OrderLots()); //   (   -)
             }
           //----
           if(OrderType() == OP_SELL)             //  Sell
             {
               s = 1;                              //   
               Close_S(OrderTicket(),OrderLots()); //   ( )
             }
           //----
           if(__buy_lim)   //  BuyLimit
             {
               OP_bl = __buy_price;
               bl = 1;     //   
             }
           //----
           if(__sell_lim)  // SellLimit
             {
               OP_sl = __sell_price;
               sl = 1;    //   
             }
         }
     }   
   MA = iMA(NULL, 0, period_MA, 0,MODE_LWMA, PRICE_TYPICAL, 0); //   
   Modify_order();    //  
   Open_order() ;     //  
//----
   return;
  } 
//+------------------------------------------------------------------+
//|    Buy                                            |
//+------------------------------------------------------------------+
void Close_B(int Nomber, double lots)
  {
   //    
   if(NormalizeDouble(Bid - OrderOpenPrice(), Digits) >= cls)
     {
       MyOrderClose(RQF_TEST, Nomber, lots, Bid, 1, Yellow);
       b = 0;                                        
     }
//----
   return;
  }
//+------------------------------------------------------------------+
//|    Sell                                           |
//+------------------------------------------------------------------+
void Close_S(int Nomber, double lots)
  {
   //    
   if(NormalizeDouble(OrderOpenPrice() - Ask, Digits) >= cls)
     {
       MyOrderClose(RQF_TEST, Nomber, lots, Ask, 1, Yellow);
       s = 0;    //    
     }
//----
   return;
  }
//+------------------------------------------------------------------+
//|                                                |
//+------------------------------------------------------------------+
void Modify_order()
  {
//----
   if(bl == 1)  //   
     {
       OP = MA - dist;    //    
       //----
       if(MathAbs(OP_bl - OP) > 0.5*Point)  //      
         {
           MyOrderPlaceBuy(__buy_lots, OP, OP - SL, OP + TP);
         }
     }
//----
   if(sl == 1)  //   
     {
       OP = MA + spred + dist;  //    
       //----
       if(MathAbs(OP_sl - OP) > 0.5*Point) //      
         {
           MyOrderPlaceSell(__sell_lots, OP, OP + SL, OP - TP); // 
         }
     }
//----
   return;
  }
//+------------------------------------------------------------------+
//|                                                |
//+------------------------------------------------------------------+
void Open_order()
  {
//   int Tek_Time=TimeHour(CurTime());               //    
//   if (Tek_Time>Time_2 && Tek_Time<Time_1) return; //    
   if(b == 0 && bl == 0)   //   ,  bl
     {
       OP = MA - dist;  //    bl      
       //----
       if(OP > Ask - Level) 
           OP = Ask - Level;  //    .  
       OP = NormalizeDouble(OP, Digits); //  (  5 ) 
       MyOrderPlaceBuy(Lots(), OP, OP - SL, OP + TP); // 
       bl = 1;   //   
     }      
//----
   if(s == 0 && sl == 0) //   ,  sl
     {
       OP = MA + spred + dist;  //    sl     
       //----
       if(OP < Bid + Level) 
           OP = Bid + Level; //    .  
       OP = NormalizeDouble(OP, Digits); //  (  5 ) 
       MyOrderPlaceSell(Lots(), OP, OP + SL, OP - TP); // 
       sl = 1;  //   sl
     }
//----
   return;
  }
//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+
double Lots()
  {
//  .  
   Lot = NormalizeDouble(AccountEquity()*Prots / 100 / 1000, 1);  
//   . 
   double Min_Lot = MarketInfo(Symbol(), MODE_MINLOT);   
//    . . 
   if(Lot == 0) 
       Lot = Min_Lot;                         
//----
   return(Lot);
  }
//+------------------------------------------------------------------+


